Loading...
Searching...
No Matches
Opm::BinaryCoeff::Brine_H2< Scalar, H2O, H2, verbose > Class Template Reference

Binary coefficients for brine and H2. More...

`#include <Brine_H2.hpp>`

## Static Public Member Functions

template<class Evaluation>
static Evaluation | calculateMoleFractions (const Evaluation &temperature, const Evaluation &pg, const Evaluation &salinity, bool extrapolate=false)
| Returns the mol (!) fraction of H2 in the liquid phase for a given temperature, pressure, and brine salinity.
template<class Evaluation>
static Evaluation | computePoyntingFactor_ (const Evaluation &temperature, const Evaluation &pg)
| Returns the Poynting Factor (PF) which is needed in calculation of H2 solubility in Li et al (2018).
template<class Evaluation>
static Evaluation | activityCoefficient_ (const Evaluation &temperature, const Evaluation &salinity)
| Returns the activity coefficient of H2 in brine which is needed in calculation of H2 solubility in Li et al (2018).
template<class Evaluation>
static Evaluation | henrysConstant_ (const Evaluation &temperature)
| Returns Henry's constant of H2 in brine which is needed in calculation of H2 solubility in Li et al (2018).
template<class Evaluation>
static Evaluation | moleFractionGasH2_ (const Evaluation &temperature, const Evaluation &pg)
| Returns mole fraction of H2 in gasous phase which is needed in calculation of H2 solubility in Li et al (2018).
template<class Evaluation>
static Evaluation | fugacityCoefficientH2 (const Evaluation &temperature, const Evaluation &pg, bool extrapolate=false)
| Calculate fugacity coefficient for H2 which is needed in calculation of H2 solubility in Li et al (2018).
template<class Evaluation>
static Evaluation | gasDiffCoeff (const Evaluation &temperature, const Evaluation &pressure)
| Binary diffusion coefficent [m^2/s] for molecular water and H2 as an approximation for brine-H2 diffusion.

## Detailed Description

template<class Scalar, class H2O, class H2, bool verbose = true>
class Opm::BinaryCoeff::Brine_H2< Scalar, H2O, H2, verbose >

Binary coefficients for brine and H2.

## Member Function Documentation

## activityCoefficient_()

template<class Scalar, class H2O, class H2, bool verbose = true>
template<class Evaluation>

Evaluation Opm::BinaryCoeff::Brine_H2< Scalar, H2O, H2, verbose >::activityCoefficient_ | ( | const Evaluation & | temperature,
|  | const Evaluation & | salinity )

inline static

Returns the activity coefficient of H2 in brine which is needed in calculation of H2 solubility in Li et al (2018).

Note that we only include NaCl effects. Could be extended with other salts, e.g. from Duan & Sun, Chem. Geol., 2003.

Parameters

  temperature | temperature [K]
  salinity | salinity [mol NaCl / kg solution]

## calculateMoleFractions()

template<class Scalar, class H2O, class H2, bool verbose = true>
template<class Evaluation>

Evaluation Opm::BinaryCoeff::Brine_H2< Scalar, H2O, H2, verbose >::calculateMoleFractions | ( | const Evaluation & | temperature,
|  | const Evaluation & | pg,
|  | const Evaluation & | salinity,
|  | bool | extrapolate = false )

inline static

Returns the mol (!) fraction of H2 in the liquid phase for a given temperature, pressure, and brine salinity.

Implemented according to Li et al., Int. J. Hydrogen Energ., 2018.

Parameters

  temperature | temperature [K]
  pg | gas phase pressure [Pa]
  salinity | salinity [kg NaCl / kg solution]
  xlH2 | mole fraction of H2 in brine [mol/mol]
  extrapolate | True to use extrapolation

## computePoyntingFactor_()

template<class Scalar, class H2O, class H2, bool verbose = true>
template<class Evaluation>

Evaluation Opm::BinaryCoeff::Brine_H2< Scalar, H2O, H2, verbose >::computePoyntingFactor_ | ( | const Evaluation & | temperature,
|  | const Evaluation & | pg )

inline static

Returns the Poynting Factor (PF) which is needed in calculation of H2 solubility in Li et al (2018).

Parameters

  temperature | temperature [K]
  pg | gas phase pressure [Pa]

## fugacityCoefficientH2()

template<class Scalar, class H2O, class H2, bool verbose = true>
template<class Evaluation>

Evaluation Opm::BinaryCoeff::Brine_H2< Scalar, H2O, H2, verbose >::fugacityCoefficientH2 | ( | const Evaluation & | temperature,
|  | const Evaluation & | pg,
|  | bool | extrapolate = false )

inline static

Calculate fugacity coefficient for H2 which is needed in calculation of H2 solubility in Li et al (2018).

The equation used is based on Helmoltz free energy EOS. The formulas here are taken from Span et al., J. Phys. Chem. Ref. Data 29, 2000 and Leachman et al., J. Phys. Chem. Ref. Data 38, 2009, and Li et al. (2018).

Parameters

  temperature | temperature [K]
  pg | gas phase pressure [Pa]
  extrapolate | True to use extrapolation

## gasDiffCoeff()

template<class Scalar, class H2O, class H2, bool verbose = true>
template<class Evaluation>

Evaluation Opm::BinaryCoeff::Brine_H2< Scalar, H2O, H2, verbose >::gasDiffCoeff | ( | const Evaluation & | temperature,
|  | const Evaluation & | pressure )

inline static

Binary diffusion coefficent [m^2/s] for molecular water and H2 as an approximation for brine-H2 diffusion.

To calculate the values, the fullerMethod is used.

## henrysConstant_()

template<class Scalar, class H2O, class H2, bool verbose = true>
template<class Evaluation>

Evaluation Opm::BinaryCoeff::Brine_H2< Scalar, H2O, H2, verbose >::henrysConstant_ | ( | const Evaluation & | temperature | ) |

inline static

Returns Henry's constant of H2 in brine which is needed in calculation of H2 solubility in Li et al (2018).

Parameters

  temperature | temperature [K]

## moleFractionGasH2_()

template<class Scalar, class H2O, class H2, bool verbose = true>
template<class Evaluation>

Evaluation Opm::BinaryCoeff::Brine_H2< Scalar, H2O, H2, verbose >::moleFractionGasH2_ | ( | const Evaluation & | temperature,
|  | const Evaluation & | pg )

inline static

Returns mole fraction of H2 in gasous phase which is needed in calculation of H2 solubility in Li et al (2018).

Parameters

  temperature | temperature [K]
  pg | gas phase pressure [Pa]

The documentation for this class was generated from the following file:

- opm/material/binarycoefficients/Brine_H2.hpp